setInfos(6, "StripJackNaked", "Play Strip Jack Naked or Beggar-my-neighbour for forfeits", 
	"NIFOC99", "v0.4", 0x1E8449, "en", ["game", "formale", "forfemale", "estim", "spanking"])

def Title = "<h1 style='font-size:140%;'>Strip Jack Naked</h1>\n\n"
def Version = "v0.4"
//send("StripJackNaked.Version", Version)//only for new versions
show(null)
setImage(null)
show(Title+"Checking version")
if(isConnected()){
	if(receiveString("StripJackNaked.Version")!=Version) {
		show(Title+"This ("+Version+") is not the latest version ("+
			receiveString("StripJackNaked.Version")+").\n\n"+
			"Check for the latest version at ss.deviatenow.com/scripts.php")
		wait(2)
		showButton("OK")
		show("")
	}
}
setImage("StripJackNaked/StripJackNaked003.jpg")
wait(2.0)

def Nb = 26
def Np = 26
def Nf = 0
def Mb = 0
def Mp = 0
def Ms = 0
def Cb = []
def Cp = []
def Cs = []
def Score = ""

//settings
def DeckName = loadString("StripJackNaked.DeckName")?: "StandardDeck1"
def Bs = loadInteger("StripJackNaked.Bs")?: 6

def Penalty
def Paid = false
def NoStack = true
def Player = false
def Play = true
def PlayerClothesN =1
def ClothesF = []
def PlayerF = 0

def EdgesSetup = false
def EdgeTime = 0
def EstimSetup = false
def EstimAudio = true
def audioFiles = []
def EstimPath = loadString("StripJackNaked.EstimPath")?: System.getProperty("user.dir")
def EstimStart = loadString("StripJackNaked.EstimStart")?: "usbcontrol.exe start"
def EstimFinish = loadString("StripJackNaked.EstimFinish")?: "usbcontrol.exe stop"

//Closures (functions)######################################################################

def ShowRules = {//rules--------------------------------------------------------------------
	setImage(null)
	show(Title+"The game was probably invented in Britain and has been known there since "+
		"at least the 1840s.\n\nIt appears in Charles Dickens's 1861 novel Great Expectations, "+
		"as the only card game Pip, the book's protagonist, knew how to play as a child.")
	showButton("next")
	show(Title+"A standard 52-card deck is dealt face-down between two players. Your opponent, "+
		"called the bank, plays a card face-up to start a central stack, and you play "+
		"cards alternating with the bank as long as no Ace or court card (King, Queen, or "+
		"Jack) appears. These cards are <em>penalty cards.</em>\n\nIf a player turns up "+
		"such a card, their opponent has to pay a penalty: four cards for an Ace, three "+
		"for a King, two for a Queen, or one for a Jack. They play the required number of "+
		"cards onto the central pile. If all the penalty cards are numerals, the player of "+
		"the penalty card wins the hand. However, if the second player turns up another "+
		"Ace or court card, their payment ceases and the other player must pay the new "+
		"penalty. Penalties may alternate many times before one is paid fully.")
		showButton("next")
	show(Title+"Once a penalty is paid, the winner takes all the cards in the pile and "+
		"places them under their pack and the game continues. The winner has the advantage "+
		"of restarting play. When a single player has all of the cards, they have won.")
		showButton("next")
	show(Title+"<em>Special rules</em>\n\nIn this script, you have the choice to do a "+
		"forfeit instead of paying the penalty cards. You can strip, do a number of edges, "+
		"take a number of slaps, or suffer a long estim shock. The forfeit depends on the "+
		"penalty card and the size of the stack at the time. A minimum baseline value of "+
		Bs+" is added to the size of the stack.\n\nThe forfeits are:<ul><li>One item "+
		"of clothing</li><li>Ace=1, King=2, Queen=3 or Jack=4 edges</li><li>Size of the "+
		"stack slaps</li><li>Stack times A=0.5, K=1.0, Q=1.5, J=2.0 seconds of shock")
	showButton("OK")
}

def ChooseDeck = {//------------------------------------------------------------------------
	def DeckNames = []
	setImage("Bcards/"+DeckName+"/"+getRandom(52)+".png")
	if(getBoolean(Title+"Current deck is "+DeckName, "select new deck", "cancel")){		
		new File(getDataFolder().replaceAll("\\\\", "/")+"images/Bcards/").eachFile() {file->
			if(file.isDirectory()) {DeckNames << file.getName()}
		}
		def i=0
		while(i<DeckNames.size){
			setImage("Bcards/"+DeckNames[i]+"/"+getRandom(52)+".png")
			if(getBoolean(Title+DeckNames[i], "select deck", "next ->")){
				DeckName = DeckNames[i]
				save("StripJackNaked.DeckName", DeckName)
				i = DeckNames.size
			}else{
				i++
				if(i==DeckNames.size)i = 0
			}
		}
	}
	setImage(null)
}

def SuffleDeal = {//------------------------------------------------------------------------
	for(def j=0; j<52; j++){
		Cb[j] = j+52
	}
	Collections.shuffle(Cb)
	for(def j=26; j<52; j++){
		Cp[j-26] = Cb[j]
		Cb[j] = -1
		Cp[j] = -1
	}
	Np = 26
	Nb = 26
}

def setupEdges = {//------------------------------------------------------------------------
	def e = true
	while(e){
		show(Title+"You have to set a baseline time for your edges\n\n"+
			"Press <b>start</b> to start the clock and <b>edge</b> when you "+
			"are there")
		showButton("start")
		EdgeTime = getTime()
		show(Title+"Press <b>edge</b> when you are there")
		showButton("edge")
		EdgeTime = getTime()-EdgeTime
		if(EdgeTime<5){
			show(Title+"Be serious - it must take longer than "+EdgeTime+" seconds")
			showButton("try again")			
		}else if(getBoolean(Title+"You took "+EdgeTime+" seconds to edge", "OK", "try again")){
			e = false
		}
	}
	EdgesSetup = true
}

def doEdges = {n -> //----------------------------------------------------------------------
	while(!EdgesSetup){
		show(Title+"You need to set a baseline for your edges")
		showButton("set up")
		setupEdges()
	}
	show(Title+"You owe "+n+" edges. Get ready.")
	showButton("ready")
	for(def i=0; i<n; i++){
		int t = getRandom((int)(EdgeTime*0.4))+(int)(EdgeTime*0.7)
		def b = getRandom(120)+60
		def speed = (1/b)*60
		def strokes = t/speed
		(1..strokes).each {
			show(Title+"Edge "+(i+1)+": rate is "+b+" beats per minute for "+t+" seconds"+
				"<p style='color:red; font-size:200%'>Stroke</p>");
			if(!EstimSetup||(EstimSetup&&!EstimAudio))playBackgroundSound("tom.wav")
			wait(speed/2)
			show(Title+"Edge "+(i+1)+": rate is "+b+" beats per minute for "+t+" seconds"+
				"<p style='font-size:200%'>Stroke</p>")
			wait(speed/2);
		}
		if(i<n-1){
			show(Title+"Relax - get ready for next time" )
			waitWithGauge(getRandom(10) + 5)
		}else{
			show(Title+"Relax - get ready to play Strip Jack Naked" )
			showButton("OK")
		}
	}
}

def doSpanks = {n -> //---------------------------------------------------------------------
	show(Title+"You owe "+n+" spanks. Get your spanking implement.")
	showButton("ready")
	setImage("StripJackNaked/StripJackNaked00"+(getRandom(2)?"1":"2")+
		(loadBoolean("intro.likefemale")?"f":"m")+".jpg")
	for(def i=1; i<n+1; i++){
		show(Title+"Spank "+i+" of "+n)
		if(!EstimSetup)playBackgroundSound("swat.wav")
		wait(1.5)
	}
	show(Title+"I hope you're sore")
	showButton("done")
}

def setupEstim = {//------------------------------------------------------------------------
	if(!loadBoolean("toys.estim")) {
		show(Title+"You don't have an estim device! You can't pay your debt. "+
			"Do edges instead")
		showButton("OK")
		EstimSetup = false
		return null
	}
	setImage("StripJackNaked/StripJackNaked005"+(loadBoolean("intro.likefemale")?"f":"m")+".jpg")
	show(Title+"You have to attach your estim device somewhere below the waist. "+
			"Make it somewhere sensitive!")
	showButton("done")
	if(getBoolean(Title+"Is your estim device worked by audio inputs?")) {
		setImage("StripJackNaked/StripJackNaked006-0.jpg")
		EstimAudio = true
		audioFiles = []
		new File(getDataFolder().replaceAll("\\\\", "/")+"sounds/StripJackNaked/").eachFile() {file->
			if(file.isFile()&&file.getAbsolutePath().indexOf(".mp3")>0)
				{audioFiles << file.getAbsolutePath()}
		}
		if(audioFiles.size<1) {
			show(Title+"Error! Cannot find sound files in sounds/StripJackNaked\n\nYou cannot "+
				"use audio estim! Add some files and set up estim again.")
			showButton("OK")
			EstimSetup = false
			return null
		}
	}else{
		setImage("StripJackNaked/StripJackNaked006-1.jpg")
		EstimAudio = false
// Define the external commands used to control the device
		EstimStart = getString(Title+"Make sure your computer is linked to your device with "+
			"the correct commands.\n\nWhat is the command your computer runs to start your "+
			"device:", EstimStart)
		EstimFinish = getString(Title+"What is the command your computer runs to stop your "+
			"device:", EstimFinish)
		EstimPath = getString(Title+"Locatiom of the command file your computer runs to "+
			"control your device:", EstimPath)
		save("StripJackNaked.EstimStart", EstimStart)
		save("StripJackNaked.EstimFinish", EstimFinish)
		save("StripJackNaked.EstimPath", EstimPath)
	}
//testing
	def e = true
	while(e) {
		if(EstimAudio){
			setImage("StripJackNaked/StripJackNaked006-0.jpg")
			if(getBoolean(Title+"You should test the level!\n\n"+
				"Don't continue until you're sure your "+
				"device is working." ,"test", "done")){
				playBackgroundSound(audioFiles[getRandom(audioFiles.size)])
				wait(1)
				playBackgroundSound(null)
				EstimSetup = true
			}else{
				EstimSetup = true
				e = false
			}
		}else{
			setImage("StripJackNaked/StripJackNaked006-1.jpg")
			if(getBoolean(Title+"You should do a quick test first!\n\n"+
					"Don't continue until you're sure your "+
					"device is working.", "test", "done")) {
				try {
					useFile(EstimPath+"/"+EstimStart)
					wait(2)
					useFile(EstimPath+"/"+EstimFinish)
					wait(1)
					EstimSetup = true
				}
				catch(def e1) {
					setImage("StripJackNaked/StripJackNaked00"+(getRandom(2)?"1":"2")+
						(loadBoolean("intro.likefemale")?"f":"m")+".jpg")
					show(Title+"There was an error. You will need to set up again.")
					showButton("OK")
					EstimSetup = false
					return null
				}
			}else{
				EstimSetup = true
				e = false
			}
		}
	}
}

def playShockSequence = {n -> //------------------------------------------------------------
	setImage("StripJackNaked/StripJackNaked00"+(getRandom(2)?"1":"2")+
		(loadBoolean("intro.likefemale")?"f":"m")+".jpg")
	show(Title+"Yor "+n+" seconds of shocks will start soon")
	waitWithGauge(5)
	show(Title+"**@|*!!*")
	def StartT = getTime()
	if(EstimAudio) {
		while(getTime()-StartT<n){playSound(audioFiles[getRandom(audioFiles.size)])}
	}else{
		try {
			useFile(EstimPath+"/"+EstimStart)
			wait(n)
			useFile(EstimPath+"/"+EstimFinish)
		}
		catch(def e1) {
			show(Title+"Error! Try again.")
			wait(2)
			return false
		}
	}
	return true
}

def doShock = {n -> //----------------------------------------------------------------------
	show(Title+"You owe "+n+" seconds of estim shocks")
	showButton("OK")
	if(!loadBoolean("toys.estim")){
		show(Title+"You don't have an estim device! You can't pay your debt. "+
			"Do an edge instead")
		showButton("OK")
		EstimSetup = false
		doEdges(1)
		return null
	}
	while(!EstimSetup){
		show(Title+"You need to set up your estim")
		showButton("set up")
		setupEstim()
	}
	def Shocked = false
	while(!Shocked){
		if(getBoolean(Title+"Are you ready to pay?", "ready", "set up estim")){
			Shocked = playShockSequence(n)
		}else{
			EstimSetup = false
			while(!EstimSetup){
				setupEstim()
			}
		}
	}
}

def getScore = {card -> //------------------------------------------------------------------
	def s
	if(card<52) s = (int)Math.ceil((card+1)/4)
	else s = (int)Math.ceil((card-51)/4)
	return s
}

def getClothesPicture = {n -> //------------------------------------------------------------
	def name = n.toLowerCase()
	if(name.count("shirt")>0&&name[0]=="t")return "tshirtM.png"
	if(name.count("belt")>0)return "beltM.png"
	if(loadBoolean("intro.female")&&(name.count("bikini")>0&&name.count("bottom")>0))
		return "bikinibottomF.png"
	if(loadBoolean("intro.female")&&(name.count("bikini")>0&&name.count("top")==0))
		return "bikinitopF.png"
	if(loadBoolean("intro.female")&&name.count("bikini")>0)return "bikinibottomF.png"
	if(!loadBoolean("intro.female")&&name.count("bikini")>0)return "bikiniM.png"
	if(name.count("blouse")>0||(loadBoolean("intro.female")&&name.count("shirt")>0))
		return "blouseF.png"
	if(name.count("boxer")>0)return "boxersM.png"
	if(name.count("bra")>0)return "braF.png"
	if(loadBoolean("intro.female")&&(name.count("bikini")>0&&name.count("bottom")>0))
		return "bikinibottomF.png"
	if(loadBoolean("intro.female")&&(name.count("coat")>0||name.count("jacket")>0))
		return "coatF.png"
	if(!loadBoolean("intro.female")&&(name.count("coat")>0||name.count("jacket")>0))
		return "coatM.png"
	if(name.count("dress")>0)return "dressF.png"
	if(name.count("hat")>0)return "hatM.png"
	if(name.count("hoodie")>0||(name.count("track")>0&&name.count("top")>0)||
		(name.count("sweat")>0&&name.count("shirt")>0))return "hoodieM.png"
	if(name.count("jock")>0)return "jockstrapM.png"
	if(name.count("panties")>0||(loadBoolean("intro.female")&&(name.count("knickers")>0||
		name.count("underpants")>0)))return "pantiesF.png"
	if(name.count("scarf")>0)return "scarfM.png"
	if(name.count("stocking")>0)return "stockingsF.png"
	if(!loadBoolean("intro.female")&&name.count("shirt")>0)return "shirtM.png"
	if(loadBoolean("intro.female")&&name.count("shoe")>0)return "shoeF.png"
	if(!loadBoolean("intro.female")&&name.count("shoe")>0)return "shoeM.png"
	if(loadBoolean("intro.female")&&name.count("shorts")>0)return "shortsF.png"
	if(!loadBoolean("intro.female")&&name.count("shorts")>0)return "shortsM.png"
	if(name.count("skirt")>0)return "skirtF.png"
	if(name.count("sock")>0)return "sockM.png"
	if(!loadBoolean("intro.female")&&(name.count("speedo")>0||(name.count("swim")>0&&
		name.count("short")==0)))return "speedosM.png"
	if(!loadBoolean("intro.female")&&(name.count("swim")>0&&name.count("short")>0))
		return "shortsM.png"
	if((name.count("sweat")>0&&name.count("pants")>0)||(name.count("track")>0&&
		(name.count("bottom")>0||name.count("pants")>0)))return "sweatpantsM.png"
	if(loadBoolean("intro.female")&&name.count("swim")>0)return "swipsuitF.png"
	if(loadBoolean("intro.female")&&name.count("thong")>0)return "thongF.png"
	if(!loadBoolean("intro.female")&&name.count("thong")>0)return "thongM.png"
	if(name.count("tie")>0)return "tieM.png"
	if(!loadBoolean("intro.female")&&(name.count("knicker")>0||name.count("underpant")>0))
		return "underpantsM.png"
	if(name.count("vest")>0)return "vestM.png"
	if(loadBoolean("intro.female")&&(name.count("pant")>0||name.count("trouser")>0))
		return "pantsF.png"
	if(!loadBoolean("intro.female")&&(name.count("pant")>0||name.count("trouser")>0))
		return "pantsM.png"
	return "unknown.png"
}

def displayClothes = {c, w -> //------------------------------------------------------------
	for(def j=c.size-1; j>=w; j--){
		show(Title+c[j])
		setImage("Bclothes/"+getClothesPicture(c[j]))
		wait(0.5)
	}
	wait(0.5)
}

def showCards= {Dp, Ds, Db -> //Display card images-----------------------------------------
	def width = 740//650
	def height = 500
	def image = new java.awt.image.BufferedImage(width, height, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
	def graphics = image.getGraphics()
	def thisImage 
	thisImage = javax.imageio.ImageIO.read(new File("images/StripJackNaked/StripJackNaked000.png"))
	graphics.drawImage(thisImage, 55, 0, null)
//get height and width of card
	def sampleImage = java.awt.Toolkit.getDefaultToolkit().getImage(
		"images/Bcards/"+DeckName+"/0.png")
	def oneWidth = sampleImage.getWidth()
	def oneHeight = sampleImage.getHeight()
//player card
	def x = 0
	def y = 0
	if(Dp>-1){
		if(Dp<52){
			thisImage = javax.imageio.ImageIO.read(new File("images/Bcards/"+DeckName+"/"+Dp+".png"))
		}else{
			thisImage = javax.imageio.ImageIO.read(new File("images/Bcards/"+DeckName+"/back.png"))
		}
		x = 55
		y = height-oneHeight-40
		graphics.drawImage(thisImage, (int)x, (int)y, null)
	}
//stack
	if(Ds>-1){
		if(Ds<52){
			thisImage = javax.imageio.ImageIO.read(new File("images/Bcards/"+DeckName+"/"+Ds+".png"))
		}else{
			thisImage = javax.imageio.ImageIO.read(new File("images/Bcards/"+DeckName+"/back.png"))
		}
		x = width/2-oneWidth/2
		y = height-oneHeight-70
		graphics.drawImage(thisImage, (int)x, (int)y, null)
	}
//bank card
	if(Db>-1){
		if(Db<52){
			thisImage = javax.imageio.ImageIO.read(new File("images/Bcards/"+DeckName+"/"+Db+".png"))
		}else{
			thisImage = javax.imageio.ImageIO.read(new File("images/Bcards/"+DeckName+"/back.png"))
		}
		x = width-55-oneWidth
		y = height-oneHeight-40
		graphics.drawImage(thisImage, (int)x, (int)y, null)
	}
//bank free goes
	for(def i=0; i<Nf; i++){
		thisImage = javax.imageio.ImageIO.read(new File("images/StripJackNaked/StripJackNaked007.png"))
		x = width-50
		y = 60+i*25
		graphics.drawImage(thisImage, (int)x, (int)y, null)
	}
//player clothes
	if(PlayerF<ClothesF.size){
		for(def i=PlayerF; i<ClothesF.size; i++){
			thisImage = javax.imageio.ImageIO.read(new File("images/Bclothes/s_"+getClothesPicture(ClothesF[i])))
			x = 0
			y = 60+(i-PlayerF)*50
			graphics.drawImage(thisImage, (int)x, (int)y, null)
		}
	}else{
		thisImage = javax.imageio.ImageIO.read(new File("images/Bclothes/s_nude"+(loadBoolean("intro.female")?"F":"M")+".png"))
		x = 0
		y = 60+82
		graphics.drawImage(thisImage, (int)x, (int)y, null)
	}
	java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream()
	javax.imageio.ImageIO.write(image, "png", baos)
	setImage(baos.toByteArray(),0)
	Score = "<table><tr><td>Player</td><td>Stack</td><td>Bank</td></tr>"+
		"<tr><td style='text-align:center'>"+(Np-Mp)+"</td><td style='text-align:center'>"+
		(Ms+1)+"</td><td style='text-align:center'>"+(Nb-Mb)+"</td></tr></table>"
	show(Title+Score)
}

Penalty = {s ->//---------------------------------------------------------------------------
	def st = ["", "four cards", "", "", "", "", "", "", "", "", "", 
		"one card", "two cards", "three cards"]
	def sn = [0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 3]
	def sf = [0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 3, 2]
	def p = true
	if(!Paid){
		Player = !Player
		if(Player){
			p = getBoolean(Title+Score+"Penalty of "+st[s]+" for the "+(Player?"player":"bank"),
				"cards", "forfeit")
		}else{
			show(Title+Score+"Penalty of "+st[s]+" for the "+(Player?"player":"bank"))
			wait(2.0)
			p = true
		}
		if(p){//pay
			def j = 0
			while(j<sn[s]){
				if(Player){
					showCards(Cp[Mp]-52, Cs[Ms]-52, Cb[Mb])
					wait(0.3)
					Ms++
					Cs[Ms] = Cp[Mp]
					if(Mp<Np-1){
						Mp++
						showCards(Cp[Mp], Cs[Ms]-52, Cb[Mb])
					}else{
						showCards(-1, Cs[Ms]-52, Cb[Mb])
						Play = false
						return
					}
					showCards(Cp[Mp], Cs[Ms]-52, Cb[Mb])
					wait(0.6)
					if(getScore(Cs[Ms])==1||getScore(Cs[Ms])>10){Penalty(getScore(Cs[Ms]))}
					if(Paid)return 
				}else{//bank
					if(Nf>0&&(((Np-Mp)>(Nb-Mb)&&getRandom(100)>50)||
						(Np-Mp)>2*(Nb-Mb))){//players cards > banks - use free go
						show(Title+Score+"Bank uses a free go!")
						wait(0.5)
						Nf--
						Paid = true
						if(Paid)return
					}else{//pay
						showCards(Cp[Mp], Cs[Ms]-52, Cb[Mb]-52)
						wait(0.6)
						Ms++
						Cs[Ms] = Cb[Mb]
						if(Mb<Nb-1){
							Mb++
							showCards(Cp[Mp], Cs[Ms]-52, Cb[Mb])
						}else{
							showCards(Cp[Mp], Cs[Ms]-52, -1)
							Play = false
							return
						}
						showCards(Cp[Mp], Cs[Ms]-52, Cb[Mb])
						wait(0.6)
						if(getScore(Cs[Ms])==1||getScore(Cs[Ms])>10){Penalty(getScore(Cs[Ms]))}
						if(Paid)return
					}
				}
				j++
			}
			show(Title+Score+(Player?"Bank":"Player")+" wins "+(Ms+1)+" cards")
			wait(2.0)
			for(def k=0; k<Np-Mp; k++){Cp[k]=Cp[k+Mp]}
			for(def k=Np-Mp; k<53; k++){Cp[k]=-1}
			Np = Np-Mp
			for(def k=0; k<Nb-Mb; k++){Cb[k]=Cb[k+Mb]}
			for(def k=Nb-Mb; k<52; k++){Cb[k]=-1}
			Nb = Nb-Mb
			if(Player){
				for(def k=0; k<Ms+1; k++){Cb[k+Nb]=Cs[k]}
				Nb = Nb+Ms+1
			}else{
				for(def k=0; k<Ms+1; k++){Cp[k+Np]=Cs[k]}
				Np = Np+Ms+1
			}
			Mp = 0
			Mb = 0
			Ms = -1
			Cs = []
			Paid = true
			NoStack = true
			return 
		}else{
//forfeit
			def PlayerBetN
			def PlayerBetOptions = []//set up suitable choices
			def PlayerBetNumber = []
			if(PlayerF<ClothesF.size){
				PlayerBetOptions.add("clothes")
				PlayerBetNumber.add(0)
			}
			PlayerBetOptions.add("edges")
			PlayerBetNumber.add(1)
			PlayerBetOptions.add("spanks")
			PlayerBetNumber.add(2)
			if(loadBoolean("toys.estim")){
				PlayerBetOptions.add("estim")
				PlayerBetNumber.add(3)
			}
			PlayerBetOptions.add("you choose")
			PlayerBetNumber.add(4)
			PlayerBetN = PlayerBetNumber[getSelectedValue(Title+Score+"Choose your forfeit", 
				PlayerBetOptions)]
			if(PlayerBetN==4){//you choose
				PlayerBetN = PlayerBetNumber[getRandom(PlayerBetOptions.size()-1)]
			}
			switch(PlayerBetN){
			case 0: //clothes
				setImage("Bclothes/"+getClothesPicture(ClothesF[PlayerF]))
				show(Title+"Your forfeit is your "+ClothesF[PlayerF])
				showButton("OK")
				show(Title+"Strip!")
				showButton("done")
				wait(0.4)
				PlayerF++
				Nf++
				if(PlayerF<ClothesF.size)setImage("Bclothes/"+getClothesPicture(ClothesF[PlayerF]))
				else setImage("Bclothes/nude"+(loadBoolean("intro.female")?"F":"M")+".png")
				show(Title+"Show some skin!")
				wait(1.0)
				break
			case 1: //edges
				show(Title+Score+"Your forfeit is "+sf[s]+" edges")
				showButton("OK")
				doEdges(sf[s])
				Nf++
				break
			case 2: //spanks
				show(Title+Score+"Your forfeit is "+(Ms+1+Bs)+" spanks")				
				showButton("OK")
				doSpanks(Ms+1+Bs)
				Nf++
				break
			case 3: //shocks
				show(Title+Score+"Your forfeit is "+((int)(Ms+1+Bs)*sf[s]/2)+" seconds of estim shocks")				
				showButton("OK")
				doShock((int)(Ms+1+Bs)*sf[s]/2)
				Nf++
				break
			}

			Paid = true
		}
	}
}

def StripJackNaked = {//main game-----------------------------------------------------------
	Paid = false
	if(Player){
		if(NoStack){
			showCards(Cp[Mp]-52, -1, Cb[Mb])
			NoStack = false
		}else{
			showCards(Cp[Mp]-52, Cs[Ms]-52, Cb[Mb])
		}
		wait(0.3)
		Ms++
		Cs[Ms] = Cp[Mp]
		if(Mp<Np-1){
			Mp++
			showCards(Cp[Mp], Cs[Ms]-52, Cb[Mb])
		}else{
			showCards(-1, Cs[Ms]-52, Cb[Mb])
			Play = false
		}
		wait(0.6)
		if(getScore(Cs[Ms])==1||getScore(Cs[Ms])>10)Penalty(getScore(Cs[Ms]))
	}else{//bank
		if(NoStack){
			showCards(Cp[Mp], -1, Cb[Mb]-52)
			NoStack = false
		}else{
			showCards(Cp[Mp], Cs[Ms]-52, Cb[Mb]-52)
		}
		wait(0.3)
		Ms++
		Cs[Ms] = Cb[Mb]
		if(Mb<Nb-1){
			Mb++
			showCards(Cp[Mp], Cs[Ms]-52, Cb[Mb])
		}else{
			showCards(Cp[Mp], Cs[Ms]-52, -1)
			Play = false
		}
		wait(0.6)
		if(getScore(Cs[Ms])==1||getScore(Cs[Ms])>10)Penalty(getScore(Cs[Ms]))
	}
	Player = !Player
}

//Start#####################################################################################

def EndGame = false
while(!EndGame){
	setImage("StripJackNaked/StripJackNaked00"+(getRandom(2)?"1":"2")+
		(loadBoolean("intro.likefemale")?"f":"m")+".jpg")
	switch(getSelectedValue(Title+"This is a game of Strip Jack Naked or "+
		"Beggar-my-neighbour, just you against the bank.", 
		["play", "rules", "settings", "end"])){
	case 0://play
//deal with clothes		
		ClothesF = []
		show(Title+"What clothes are you wearing?")
		showButton("my clothes")

		def e = true
		while(e){
			def f = false
			def t = ""
			while(!f){
				t = getString(Title+"List your clothes in the order you will surrender them "+
					"or 'end' if you've finished", "")
				if(t!="end"){
					show(Title+t)
					setImage("Bclothes/"+getClothesPicture(t))
					f = getBoolean(Title+"Is this OK?")
				}else{
					f = true
					e = false
				}
			}
			if(e){ClothesF.add(t)}
		}

		PlayerF = 0

		SuffleDeal()
		Mp = 0
		Mb = 0
		Ms = -1
		Nf = ClothesF.size
		NoStack = true
		Player = false
		Play = true
		while(Play){
			StripJackNaked()
		}
		if(Np<Nb){
			show(Title+"Bank wins")
			showButton("OK")
		}else{
			show(Title+"Player wins")
			showButton("OK")
		}
		break
	case 1://rules
		ShowRules()
		break
	case 2:
		ChooseDeck()
		Bs = getInteger(Title+"Baseline value added to the size of the stack for "+
			"calculating forfeits", 6)
		break
	case 3:
		setImage(null)
		show(null)
		EndGame = true
		wait(2)
	}
}
// This script, from http://ss.deviatenow.com, is protected by this licence :
// CC BY-SA 4.0, see http://creativecommons.org/licenses/by-sa/4.0/
/*
 * Resources
 * scripts/StripJackNaked.groovy
 * scripts/BeggarMyNeighbour.groovy
 * images/StripJackNaked/*.jpg
 * images/StripJackNaked/*.png
 * images/Bcards/StandardDeck1/*.png
 * images/Bclothes/*.png
 * sounds/StripJackNaked/*.mp3
 */
